Attribute VB_Name = "modDOS"
Option Explicit

Public Enum eFocus
 Hide = 0
 NormalFocus = 1
 MinimizedFocus = 2
 MaximizedFocus = 3
 NormalNoFocus = 4
 MinimizedNoFocus = 6
End Enum

Public TaskID As Long, hDOSProgram As Long, hSysMenuMark As Long

Public Sub StartDOSProgram(DOSProgram As String, WindowTitle As String, Focus As eFocus, Optional WaitMilliSeconds As Long, Optional ParentForm As Form)
'.------------------------------------------------------------------------------
'.  Funktion :  Startet ein Programm
'.
'.
'.  Vorauss. : Das Programm muss existieren.
'.
'.  Parameter: DOSProgram  - Pfad zum Programm
'.             WindowTitle - Fenstertitel des Programms
'.             Focus       - Welchen Focus soll das Programm erhalten
'.             Parentform  - Das Elternfenster. Dadurch kann das Programm an das Steuerprogramm 'angedockt' werden.
'.
'.  Rckgabe : -
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 TaskID = Shell(DOSProgram, Focus)
 If WaitMilliSeconds > 0 Then
  Sleep WaitMilliSeconds
 End If
 
 If WindowTitle = "" Then
  WindowTitle = DOSProgram
 End If
 hDOSProgram = FindWindow(vbNullString, WindowTitle)
 
 If Not ParentForm Is Nothing Then
  With ParentForm
   MoveWindow hDOSProgram, .Left / Screen.TwipsPerPixelX, (.Top + .Height) / Screen.TwipsPerPixelY, .Width / Screen.TwipsPerPixelX, .Height / Screen.TwipsPerPixelY, 1
  End With
 End If
 
 hSysMenuMark = SearchMarkInSysMenu(hDOSProgram)
 
 DoEvents
End Sub

Public Function DOSProgramIsRunning(WindowTitle As String) As Boolean
'.------------------------------------------------------------------------------
'.  Funktion :  Stellt an Hand des Fenstertitels fest, ob ein Programm bereits
'.              gestartet wurde.
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: WindowTitle - Fenstertitel
'.
'.  Rckgabe : True  - Programm wurde bereits gestartet.
'.             False - Programm wurde noch nicht gestartet.
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 DOSProgramIsRunning = False
 If FindWindow(vbNullString, WindowTitle) <> 0 Then
  DOSProgramIsRunning = True
 End If
End Function

Public Function CopyCompleteDOSScreen(Optional KeyWaitMilliSeconds As Long = 0) As String
'.------------------------------------------------------------------------------
'.  Funktion :  Kopiert den kompletten Bildschirminhalt eines DOS-Programmes.
'.              Arbeitet schneller als die Funktion CopyDOSScreen.
'.
'.  Vorauss. : Windows NT und darber. Funktioniert NICHT unter Windows 9x.
'.
'.  Parameter: KeyWaitMilliSeconds - Wartezeit nach jedem Tastendruck
'.
'.  Rckgabe : -
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 Dim i As Long
 With Clipboard
  Call SetDOSMark: Sleep 2 * KeyWaitMilliSeconds
  SendDOSKeys "+{PGDN}", KeyWaitMilliSeconds
  For i = 1 To 79
   SendDOSKeys "+{right 1}", KeyWaitMilliSeconds
  Next i
  SendDOSKeys "{Enter}", KeyWaitMilliSeconds
  CopyCompleteDOSScreen = .GetText
 End With
 DoEvents
End Function

Public Function CopyDOSScreen(xStart As Long, yStart As Long, xWidth As Long, yWidth As Long, Optional KeyWaitMilliSeconds As Long = 0) As String
'.------------------------------------------------------------------------------
'.  Funktion :  Kopiert einen Ausschnitt eines DOS-Programmes.
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: xStart, yStart      - Startkoorinaten
'.             xWidth, yWidth      - Breite, Lnge des zu kopierenden Ausschnittes
'.             KeyWaitMilliSeconds - Wartezeit nach jedem Tastendruck
'.
'.  Rckgabe : -
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 Dim i As Long
 With Clipboard
  Call SetDOSMark: Sleep 2 * KeyWaitMilliSeconds
  For i = 1 To xStart - 1
   SendDOSKeys "{right 1}", KeyWaitMilliSeconds
  Next i
  For i = 1 To yStart - 1
   SendDOSKeys "{down 1}", KeyWaitMilliSeconds
  Next i
  SendDOSKeys "{CAPSLOCK}", KeyWaitMilliSeconds
  For i = 1 To yWidth - 1
   SendDOSKeys "+{down 1}", KeyWaitMilliSeconds
  Next i
  For i = 1 To xWidth - 1
   SendDOSKeys "+{right 1}", KeyWaitMilliSeconds
  Next i
  SendDOSKeys "{CAPSLOCK}", KeyWaitMilliSeconds
  SendDOSKeys "{Enter}", KeyWaitMilliSeconds
  CopyDOSScreen = .GetText
 End With
 DoEvents
End Function

Public Sub SetDOSMark()
'.------------------------------------------------------------------------------
'.  Funktion :  Aktiviert den Systemmeneintrag 'Markieren' des Programmes
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: -
'.
'.  Rckgabe : -
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 SysMenuClick hDOSProgram, hSysMenuMark
End Sub

Public Function ReplaceSendkeyCommands(CmdStr As String) As String
'.------------------------------------------------------------------------------
'.  Funktion :  Ersetzt spez. Kommandozeichen
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: cmdStr - String der berprft werden soll
'.
'.  Rckgabe : String mit den ersetzten Kommandozeichen
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 Dim tStr As String
 tStr = ReplaceVB5(CmdStr, vbCrLf, "{Enter}")
 tStr = ReplaceVB5(tStr, "+", "{+}")
 tStr = ReplaceVB5(tStr, "^", "{^}")
 tStr = ReplaceVB5(tStr, "%", "{%}")
 ReplaceSendkeyCommands = ReplaceVB5(tStr, "~", "{~}")
End Function

Private Function SearchMarkInSysMenu(hProgram As Long) As Long
'.------------------------------------------------------------------------------
'.  Funktion :  Ermittelt das Handel auf dem Systemmen Eintrag 'Markieren'.
'.              Es wird auch das ein englisches Betriebssystem bercksichtigt.
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: hProgram - Das Fensterhandel des Programms.
'.
'.  Rckgabe : Handel auf dem Systemmen Eintrag 'Markieren'
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 Dim hSysMenu As Long, hSubMenu As Long, SubMenuCount As Long, MenuCount As Long, _
  i As Long, j As Long, menID As Long, menSID As Long, mText As String, res As Long
 hSysMenu = GetSystemMenu(hProgram, False)
 If hSysMenu <> 0 Then
   MenuCount = GetMenuItemCount(hSysMenu)
   For i = 1 To MenuCount
    menID = GetMenuItemID(hSysMenu, i - 1)
    If menID = -1 Then ' SubMenu gefunden
     mText = String(256, 0)
     res = GetMenuString(hSysMenu, i - 1, mText, 127, 1024)
     mText = Left(mText, res)
     mText = Trim$(ReplaceVB5(ReplaceVB5(mText, Chr$(0), ""), "&", ""))
     If UCase$(mText) = "BEARBEITEN" Or UCase$(mText) = "EDIT" Then
      hSubMenu = GetSubMenu(hSysMenu, i - 1)
      SubMenuCount = GetMenuItemCount(hSubMenu)
      For j = 1 To SubMenuCount
       menSID = GetMenuItemID(hSubMenu, j - 1)
       mText = String(256, 0)
       res = GetMenuString(hSubMenu, menSID, mText, 127, 0)
       mText = Left(mText, res)
       mText = ReplaceVB5(ReplaceVB5(mText, Chr$(0), ""), "&", "")
       If InStr(UCase$(mText), "MARK") = 1 Then
        SearchMarkInSysMenu = menSID
        Exit Function
       End If
      Next j
     End If
    End If
   Next i
  Else
   MsgBox "Dies scheint kein DOS-Programm zu sein!" & vbCrLf & _
    "Das Programm wird beendet!", vbCritical
   End
 End If
End Function
